/*
 * libwifi.c
 *
 *  Created on: 19 Feb 2018
 *      Author: ctorr
 */

#include "wifi.h"
#include <string.h>

#pragma melstatic
BYTE DRIVER_AID[] = { 0x04, 0xF5, 0x00, 0x00, 0x01 };

// Delegate to driver application setting up protocol flags correctly.
static void delegate(BYTE insVal, BYTE p1Val, BYTE p2Val, WORD LcVal, WORD LeVal, BOOL case4)
{
	CLA = 0x70;
	INS = insVal;
	P1 = p1Val;
	P2 = p2Val;
	La = 0;
	Lc = LcVal;
	Le = LeVal;
	if(Lc > 0)
		ProtocolFlags |= 2;
	if(Le > 0 || case4)
		ProtocolFlags |= 4;
	multosDelegate(DRIVER_AID);
}

WORD wifiInit(BYTE bInterfaceType, BYTE bInterfaceId)
{
	delegate(WIFI_SETUP_INS, bInterfaceType, bInterfaceId, 0, 0, FALSE);
	return(SW12);
}

WORD wifiBegin(void)
{
	delegate(WIFI_CONNECT_INS, 0x00, 0x00, sizeof(wifiConnectApdu_t), 0, FALSE);
	return(SW12);
}

WORD wifiHttpGet(void)
{
	delegate(WIFI_HTTPGET_INS,0x00,0x00, sizeof(wifiHttpGetReqApdu_t),0, TRUE);
	return(SW12);
}

WORD mqttConnect(void)
{
	delegate(WIFI_MQTT_INS,MQTT_CONNECT,0x00, sizeof(mqttConnectApdu_t),0, TRUE);
	return(SW12);
}

WORD mqttDisconnect(void)
{
	delegate(WIFI_MQTT_INS,MQTT_DISCONNECT,0x00, 1 ,0, TRUE);
	return(SW12);
}

WORD mqttPublish(void)
{
	delegate(WIFI_MQTT_INS,MQTT_PUBLISH,0x00, sizeof(mqttPublishApdu_t),0, TRUE);
	return(SW12);
}
